﻿package commands.main
{	
	/**
	 * RED5 Open Source Flash Server - http://www.osflash.org/red5
	 *
	 * Copyright (c) 2006-2009 by respective authors (see below). All rights reserved.
	 *
	 * This library is free software; you can redistribute it and/or modify it under the
	 * terms of the GNU Lesser General Public License as published by the Free Software
	 * Foundation; either version 2.1 of the License, or (at your option) any later
	 * version.
	 *
	 * This library is distributed in the hope that it will be useful, but WITHOUT ANY
	 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
	 * PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
	 *
	 * You should have received a copy of the GNU Lesser General Public License along
	 * with this library; if not, write to the Free Software Foundation, Inc.,
	 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
	 */
	 
	import business.NetConnectionDelegate;
	
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	
	import events.StartConnectionEvent;
	
	import model.DataModel;
	
	
	/**
	 * Connect to the RTMP server with the <code>nc</code> NetConnection.
	 * 
	 * @see org.red5.samples.publisher.model.Media#nc nc
	 * @author Thijs Triemstra
	 */	
	public class StartConnectionCommand implements ICommand 
	{			
		private var _dataModel : DataModel = DataModel.getInstance();
	 		
	 	private var netConnectionDelegate : NetConnectionDelegate = _dataModel.netConnectionDelegate;
	 
	 	/**
	 	 * 
	 	 * @param cgEvent
	 	 */	 	 	
	 	public function execute ( cgEvent : CairngormEvent ) : void
	    { 
			var event : StartConnectionEvent = StartConnectionEvent( cgEvent );
			var uri : String = 		event.uri;
			var proxy : String = 	event.proxy;
			var encoding : uint = 	event.encoding;
			// Use Delegate to create a connection to the RTMP server.
	      	netConnectionDelegate.connect( uri, proxy, encoding );
		}
		
	}
}